<template>
  <div class="d-flex flex-sm-row flex-md-column flex-lg-row justify-content-start
    justify-content-lg-end mt-2 text-md-right col text-left distribution-actions">
    <!-- button of new visualization tool -->
    <distribution-visualize-button v-if="showVisualisationButton" class="distribution-action btn btn-sm visualise-btn pt-0" @displayVisualisation="$emit('displayVisualisation', getDownloadUrl)" :isUrlInvalid="isUrlInvalid"
    :getVisualisationLink="getVisualisationLink" :distribution="distribution" :openIfValidUrl="openIfValidUrl">{{ $t('message.datasetDetails.preview') }}</distribution-visualize-button>
    <!-- TODO: remove distribution-preview button once the new visualisation service is online -->
    <distribution-preview v-if="!hidePreviewButton &&  getCatalog.is_part_of  !== 'erpd' && !showVisualisationButton" :isUrlInvalid="isUrlInvalid"
      :getVisualisationLink="getVisualisationLink" :distribution="distribution" :openIfValidUrl="openIfValidUrl"
      :previewLinkCallback="previewLinkCallback" class="distribution-action" />
    <distribution-download v-if="showDownloadDropdown(distribution)" :getDownloadUrl="getDownloadUrl"
      :showAccessUrls="showAccessUrls" :isOnlyOneUrl="isOnlyOneUrl" :trackGoto="trackGoto"
      :getDistributionFormat="getDistributionFormat" :replaceHttp="replaceHttp" :distribution="distribution"
      class="distribution-action distribution-download" />
    <linked-data-buttons-dropdown :distributions="distributions" :distribution="distribution"
      class="distribution-action" />
    <div>
      <app-link v-if="showValidateButton" class="btn btn-sm validate-btn pt-0"
        :to="{ name: 'DatasetDetailsQuality', query: { locale: $route.query.locale, validate: distribution.id } }">
        Validate
      </app-link>
    </div>
  </div>
</template>

<script>
import AppLink from "../../../widgets/AppLink";
import DistributionVisualizeButton from "../../../datasetDetails/distributions/distributionActions/DistributionVisualizeButton";
import DistributionPreview from "../../../datasetDetails/distributions/distributionActions/DistributionPreview";
import DistributionDownload from "../../../datasetDetails/distributions/distributionActions/DistributionDownload";
import LinkedDataButtonsDropdown
  from "../../../datasetDetails/distributions/distributionActions/LinkedDataButtonsDropdown";
import {mapGetters} from "vuex";
import {has, isNil} from "lodash";

export default {
  name: "DistributionActions",
  components: { AppLink, LinkedDataButtonsDropdown, DistributionDownload, DistributionPreview, DistributionVisualizeButton },
  props: {
    distribution: Object,
    distributions: Object,
    isUrlInvalid: Function,
    getVisualisationLink: Function,
    showTooltipVisualiseButton: Function,
    previewLinkCallback: Function,
    openIfValidUrl: Function,
    showDownloadDropdown: Function,
    getDownloadUrl: Function,
    showAccessUrls: Function,
    isOnlyOneUrl: Function,
    trackGoto: Function,
    getDistributionFormat: Function,
    replaceHttp: Function,
  },
  data() {
    return {
      showVisualisationButton: this.$env.content.datasetDetails.distributions.showVisualisation,
      visualisationLinkFormats: [
        'csv',
        'tsv',
        'ods',
        'xlsx',
        'xls',
      ],
    }
  },
  computed: {
    ...mapGetters('datasetDetails', [
      'getCatalog',
    ]),
    showValidateButton() {
      return this.$env?.content?.datasetDetails?.distributions?.showValidationButton;
    },
    hidePreviewButton() {
      // only returns true if the config variable hidePreviewButton exists and is set to true
      return this.$env?.content?.datasetDetails?.distributions?.hidePreviewButton;
    }
  },
  methods: {
    showVisualisationLink(distribution) {
      if (!has(distribution, 'format.label') || isNil(distribution?.format?.label)
        || (isNil(distribution?.downloadUrls[0]) && isNil(distribution?.accessUrl[0]))) return false;
      const f = distribution?.format?.id?.toLowerCase();
      return f && this.visualisationLinkFormats.includes(f);
    }
  }
}
</script>

<style lang="scss" scoped>
.validate-btn {
  color: #0e47cb;
  vertical-align: text-bottom;
  text-decoration: none;
}
</style>
